TEMPLATE = app
TARGET = desq-shell

QT += widgets dbus svg concurrent

INCLUDEPATH += /usr/include/libdesq/ /usr/include/libdesqui/
LIBS += -ldesq -ldesqui -lpam -ldesq-wl

INCLUDEPATH += . Shell Plugins Widgets
DEPENDPATH += . Shell Plugins Widgets icons

CONFIG += link_pkgconfig
PKGCONFIG += dbusmenu-qt5

# Headers
HEADERS += Shell/DesQShell.hpp
HEADERS += Shell/DesQShellAdaptor.hpp

# Sources
SOURCES += Shell/DesQShell.cpp
SOURCES += Shell/DesQShellAdaptor.cpp
SOURCES += Main.cpp

#
# Widgets
#

# Common Widgets
INCLUDEPATH += Widgets/Common
DEPENDPATH += Widgets/Common
# HEADERS += Widgets/Common/UsageGraph.hpp
# SOURCES += Widgets/Common/UsageGraph.cpp

# Brightness Widget
INCLUDEPATH += Widgets/Brightness
DEPENDPATH += Widgets/Brightness
HEADERS += Widgets/Brightness/BrightnessWidget.hpp
SOURCES += Widgets/Brightness/BrightnessWidget.cpp

# Clock Widget
INCLUDEPATH += Widgets/Clock
DEPENDPATH += Widgets/Clock
HEADERS += Widgets/Clock/ClockWidget.hpp
SOURCES += Widgets/Clock/ClockWidget.cpp

# Menu Widget
INCLUDEPATH += Widgets/Menu
DEPENDPATH += Widgets/Menu
HEADERS += Widgets/Menu/DesQMenu.hpp
HEADERS += Widgets/Menu/DesQMenuViews.hpp

SOURCES += Widgets/Menu/DesQMenu.cpp
SOURCES += Widgets/Menu/DesQMenuViews.cpp

# LogoutDialog Widget
INCLUDEPATH += Widgets/LogoutDialog
DEPENDPATH += Widgets/LogoutDialog
HEADERS += Widgets/LogoutDialog/LogoutDialog.hpp
SOURCES += Widgets/LogoutDialog/LogoutDialog.cpp

# Resources Widget
INCLUDEPATH += Widgets/Resources
DEPENDPATH += Widgets/Resources
HEADERS += Widgets/Resources/ResourcesWidget.hpp
SOURCES += Widgets/Resources/ResourcesWidget.cpp

# Sound Widget
INCLUDEPATH += Widgets/Sound
DEPENDPATH += Widgets/Sound
HEADERS += Widgets/Sound/VolumeWidget.hpp
SOURCES += Widgets/Sound/VolumeWidget.cpp

# SNI
INCLUDEPATH += Widgets/SNI
DEPENDPATH += Widgets/SNI
LIBS += -LWidgets/SNI/ -lSNI

# Resources
RESOURCES += icons/icons.qrc

# Silent compilation
CONFIG += silent

# Build location
BUILD_PREFIX = $$(DESQ_BUILD_DIR)

isEmpty( BUILD_PREFIX ) {
	BUILD_PREFIX = ./build
}

MOC_DIR 	= $$BUILD_PREFIX/Shell/moc
OBJECTS_DIR = $$BUILD_PREFIX/Shell/obj
RCC_DIR		= $$BUILD_PREFIX/Shell/qrc
UI_DIR      = $$BUILD_PREFIX/Shell/uic

unix {
	isEmpty(PREFIX) {
		PREFIX = /usr
	}
	BINDIR = $$PREFIX/bin/

	INSTALLS += target icons bg data
	target.path = $$BINDIR

	icons.path = $$PREFIX/share/icons/hicolor/256x256/apps/
	icons.files = icons/desq.png

	bg.path = $$PREFIX/share/desq/resources/
	bg.files = resources/default.jpg resources/screenlock.jpg

	data.path = $$PREFIX/share/desq-shell/
	data.files = README.md Changelog ReleaseNotes
}
