/*
	*
	* Copyright 2019 Britanicus <marcusbritanicus@gmail.com>
	*
	* This file is a part of DesQ project ( https://gitlab.com/desq/ )
	*

	*
	* This program is free software; you can redistribute it and/or modify
	* it under the terms of the GNU General Public License as published by
	* the Free Software Foundation; either version 3 of the License, or
	* ( at your option ) any later version.
	*

	*
	* This program is distributed in the hope that it will be useful,
	* but WITHOUT ANY WARRANTY; without even the implied warranty of
	* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	* GNU General Public License for more details.
	*

	*
	* You should have received a copy of the GNU General Public License
	* along with this program; if not, write to the Free Software
	* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	* MA 02110-1301, USA.
	*
*/

#pragma once

#include "Global.hpp"

class DesQMenu;
class DesQDropDown;

class WaylandRegistry;
class LayerSurface;

class QDBusInterface;

class DesQShell : public QWidget {
	Q_OBJECT

	public:
		DesQShell( QString img = QString() );

		void setupWayland( WaylandRegistry *reg );

	private:
		void prepareBackgroundImage();
		void createShellInterface();
		void createDesktopWidgets();

		QGridLayout *desktopLyt;
		QToolButton *startBtn;

		QString bgImagePath;
		QString cachedImagePath;
		QImage desktopImage;

		DesQMenu *shellMenu;
		DesQDropDown *dropDown;

		WaylandRegistry *registry;
		LayerSurface *dropDownSurface;

		QDBusInterface *session;

	public Q_SLOTS:
		void handleHotCorner( int );
		void cancelHotCorner( int );

		void showMenu();
		void lockScreen();
		void resizeDesktop();

		void handleMessages( const QString );

	protected:
		void paintEvent( QPaintEvent *pEvent );
};
